##// END OF EJS Templates
using netselect-apt to autoconfigure apt source...
Unknown -
r307:5ae5aba2ff0f
parent child
Show More
@@ -1,62 +1,63
1 #
1 #
2 # Setup APT repositories
2 # Setup APT repositories
3 #
3 #
4
4
5 # Load utility functions
5 # Load utility functions
6 . ./functions.sh
6 . ./functions.sh
7
7
8 # Install and setup APT proxy configuration
8 # Install and setup APT proxy configuration
9 if [ -z "$APT_PROXY" ] ; then
9 if [ -z "$APT_PROXY" ] ; then
10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
12 fi
12 fi
13
13
14 if [ "$BUILD_KERNEL" = false ] ; then
14 if [ "$BUILD_KERNEL" = false ] ; then
15 if [ "$RPI_MODEL" = 2 ] ; then
15 if [ "$RPI_MODEL" = 2 ] ; then
16 # Install APT pinning configuration for flash-kernel package
16 # Install APT pinning configuration for flash-kernel package
17 install_readonly files/apt/flash-kernel "${ETC_DIR}/apt/preferences.d/flash-kernel"
17 install_readonly files/apt/flash-kernel "${ETC_DIR}/apt/preferences.d/flash-kernel"
18
18
19 # Install APT sources.list
19 # Install APT sources.list
20 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
20 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
21 echo "deb ${COLLABORA_URL} ${RELEASE} rpi2" >> "${ETC_DIR}/apt/sources.list"
21 echo "deb ${COLLABORA_URL} ${RELEASE} rpi2" >> "${ETC_DIR}/apt/sources.list"
22
22
23 # Upgrade collabora package index and install collabora keyring
23 # Upgrade collabora package index and install collabora keyring
24 chroot_exec apt-get -qq -y update
24 chroot_exec apt-get -qq -y update
25 chroot_exec apt-get -qq -y --allow-unauthenticated install collabora-obs-archive-keyring
25 chroot_exec apt-get -qq -y --allow-unauthenticated install collabora-obs-archive-keyring
26 # if RPI_MODEL = [0] || [1] || [1P]
26 # if RPI_MODEL = [0] || [1] || [1P]
27 else
27 else
28 echo "error: ATM there is just a precompiled kernel for model 2";
28 echo "error: ATM there is just a precompiled kernel for model 2";
29 # insert apt configuration for precompiled kernel repository for RPI 0,1,1P
29 # insert apt configuration for precompiled kernel repository for RPI 0,1,1P
30 fi
30 fi
31
31
32 else # BUILD_KERNEL=true
32 else # BUILD_KERNEL=true
33 # Install APT sources.list
33 #autconfigure best apt server to not spam ftp.debian.org
34 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
34 rm files/apt/sources.list
35
35 if [ "$ENABLE_NONFREE" ] ; then
36 # Use specified APT server and release
36 netselect-apt --arch "$RELEASE_ARCH" --sources --nonfree --outfile "${ETC_DIR}/apt/sources.list" -d "$RELEASE"
37 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
37 else
38 sed -i "s/ jessie/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
38 netselect-apt --arch "$RELEASE_ARCH" --sources --nonfree --outfile "${ETC_DIR}/apt/sources.list" -d "$RELEASE"
39 fi
39 fi
40 fi
40
41
41 # Allow the installation of non-free Debian packages
42 # Allow the installation of non-free Debian packages
42 if [ "$ENABLE_NONFREE" = true ] ; then
43 if [ "$ENABLE_NONFREE" = true ] ; then
43 sed -i "s/ contrib/ contrib non-free/" "${ETC_DIR}/apt/sources.list"
44 sed -i "s/ contrib/ contrib non-free/" "${ETC_DIR}/apt/sources.list"
44 fi
45 fi
45
46
46 # Upgrade package index and update all installed packages and changed dependencies
47 # Upgrade package index and update all installed packages and changed dependencies
47 chroot_exec apt-get -qq -y update
48 chroot_exec apt-get -qq -y update
48 chroot_exec apt-get -qq -y -u dist-upgrade
49 chroot_exec apt-get -qq -y -u dist-upgrade
49
50
50 if [ "$APT_INCLUDES_LATE" ] ; then
51 if [ "$APT_INCLUDES_LATE" ] ; then
51 chroot_exec apt-get -qq -y install $(echo $APT_INCLUDES_LATE |tr , ' ')
52 chroot_exec apt-get -qq -y install $(echo $APT_INCLUDES_LATE |tr , ' ')
52 fi
53 fi
53
54
54 if [ -d packages ] ; then
55 if [ -d packages ] ; then
55 for package in packages/*.deb ; do
56 for package in packages/*.deb ; do
56 cp $package ${R}/tmp
57 cp $package ${R}/tmp
57 chroot_exec dpkg --unpack /tmp/$(basename $package)
58 chroot_exec dpkg --unpack /tmp/$(basename $package)
58 done
59 done
59 fi
60 fi
60 chroot_exec apt-get -qq -y -f install
61 chroot_exec apt-get -qq -y -f install
61
62
62 chroot_exec apt-get -qq -y check
63 chroot_exec apt-get -qq -y check
@@ -1,769 +1,772
1 #!/bin/sh
1 #!/bin/sh
2
2
3 ########################################################################
3 ########################################################################
4 # rpi23-gen-image.sh 2015-2017
4 # rpi23-gen-image.sh 2015-2017
5 #
5 #
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 #
7 #
8 # This program is free software; you can redistribute it and/or
8 # This program is free software; you can redistribute it and/or
9 # modify it under the terms of the GNU General Public License
9 # modify it under the terms of the GNU General Public License
10 # as published by the Free Software Foundation; either version 2
10 # as published by the Free Software Foundation; either version 2
11 # of the License, or (at your option) any later version.
11 # of the License, or (at your option) any later version.
12 #
12 #
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 #
14 #
15 # Big thanks for patches and enhancements by 20+ github contributors!
15 # Big thanks for patches and enhancements by 20+ github contributors!
16 ########################################################################
16 ########################################################################
17
17
18 # Are we running as root?
18 # Are we running as root?
19 if [ "$(id -u)" -ne "0" ] ; then
19 if [ "$(id -u)" -ne "0" ] ; then
20 echo "error: this script must be executed with root privileges!"
20 echo "error: this script must be executed with root privileges!"
21 exit 1
21 exit 1
22 fi
22 fi
23
23
24 # Check if ./functions.sh script exists
24 # Check if ./functions.sh script exists
25 if [ ! -r "./functions.sh" ] ; then
25 if [ ! -r "./functions.sh" ] ; then
26 echo "error: './functions.sh' required script not found!"
26 echo "error: './functions.sh' required script not found!"
27 exit 1
27 exit 1
28 fi
28 fi
29
29
30 # Load utility functions
30 # Load utility functions
31 . ./functions.sh
31 . ./functions.sh
32
32
33 # Load parameters from configuration template file
33 # Load parameters from configuration template file
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 use_template
35 use_template
36 fi
36 fi
37
37
38 # Introduce settings
38 # Introduce settings
39 set -e
39 set -e
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 set -x
41 set -x
42
42
43 # Raspberry Pi model configuration
43 # Raspberry Pi model configuration
44 RPI_MODEL=${RPI_MODEL:=2}
44 RPI_MODEL=${RPI_MODEL:=2}
45
45
46 # Debian release
46 # Debian release
47 RELEASE=${RELEASE:=jessie}
47 RELEASE=${RELEASE:=jessie}
48
48
49 #Kernel Branch
49 #Kernel Branch
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
51
51
52 # URLs
52 # URLs
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59
59
60 # Build directories
60 # Build directories
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
61 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
62 BUILDDIR="${BASEDIR}/build"
62 BUILDDIR="${BASEDIR}/build"
63
63
64 # Prepare date string for default image file name
64 # Prepare date string for default image file name
65 DATE="$(date +%Y-%m-%d)"
65 DATE="$(date +%Y-%m-%d)"
66 if [ -z "$KERNEL_BRANCH" ] ; then
66 if [ -z "$KERNEL_BRANCH" ] ; then
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
67 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
68 else
68 else
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
70 fi
70 fi
71
71
72 # Chroot directories
72 # Chroot directories
73 R="${BUILDDIR}/chroot"
73 R="${BUILDDIR}/chroot"
74 ETC_DIR="${R}/etc"
74 ETC_DIR="${R}/etc"
75 LIB_DIR="${R}/lib"
75 LIB_DIR="${R}/lib"
76 BOOT_DIR="${R}/boot/firmware"
76 BOOT_DIR="${R}/boot/firmware"
77 KERNEL_DIR="${R}/usr/src/linux"
77 KERNEL_DIR="${R}/usr/src/linux"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
78 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
79
79
80 # Firmware directory: Blank if download from github
80 # Firmware directory: Blank if download from github
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
81 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
82
82
83 # General settings
83 # General settings
84 SET_ARCH=${SET_ARCH}
84 SET_ARCH=${SET_ARCH}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
85 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
86 PASSWORD=${PASSWORD:=raspberry}
86 PASSWORD=${PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
87 USER_PASSWORD=${USER_PASSWORD:=raspberry}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
88 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
89 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
90 EXPANDROOT=${EXPANDROOT:=true}
90 EXPANDROOT=${EXPANDROOT:=true}
91
91
92 # Keyboard settings
92 # Keyboard settings
93 XKB_MODEL=${XKB_MODEL:=""}
93 XKB_MODEL=${XKB_MODEL:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
94 XKB_LAYOUT=${XKB_LAYOUT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
95 XKB_VARIANT=${XKB_VARIANT:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
96 XKB_OPTIONS=${XKB_OPTIONS:=""}
97
97
98 # Network settings (DHCP)
98 # Network settings (DHCP)
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
99 ENABLE_DHCP=${ENABLE_DHCP:=true}
100
100
101 # Network settings (static)
101 # Network settings (static)
102 NET_ADDRESS=${NET_ADDRESS:=""}
102 NET_ADDRESS=${NET_ADDRESS:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
103 NET_GATEWAY=${NET_GATEWAY:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
104 NET_DNS_1=${NET_DNS_1:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
105 NET_DNS_2=${NET_DNS_2:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
106 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
107 NET_NTP_1=${NET_NTP_1:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
108 NET_NTP_2=${NET_NTP_2:=""}
109
109
110 # APT settings
110 # APT settings
111 APT_PROXY=${APT_PROXY:=""}
111 APT_PROXY=${APT_PROXY:=""}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
112 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
113
113
114 # Feature settings
114 # Feature settings
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
115 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
116 ENABLE_I2C=${ENABLE_I2C:=false}
116 ENABLE_I2C=${ENABLE_I2C:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
117 ENABLE_SPI=${ENABLE_SPI:=false}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
118 ENABLE_IPV6=${ENABLE_IPV6:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
119 ENABLE_SSHD=${ENABLE_SSHD:=true}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
120 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
121 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
122 ENABLE_SOUND=${ENABLE_SOUND:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
123 ENABLE_DBUS=${ENABLE_DBUS:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
124 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
125 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
126 ENABLE_XORG=${ENABLE_XORG:=false}
127 ENABLE_WM=${ENABLE_WM:=""}
127 ENABLE_WM=${ENABLE_WM:=""}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
128 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
129 ENABLE_USER=${ENABLE_USER:=true}
130 USER_NAME=${USER_NAME:="pi"}
130 USER_NAME=${USER_NAME:="pi"}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
131 ENABLE_ROOT=${ENABLE_ROOT:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
132 ENABLE_QEMU=${ENABLE_QEMU:=false}
133
133
134 # SSH settings
134 # SSH settings
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
135 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
136 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
137 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
138 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
139 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
140
140
141 # Advanced settings
141 # Advanced settings
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
142 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
143 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
144 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
145 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
146 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
147 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
148 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
149 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
150 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
151 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
152 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
153 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
154
154
155 # Kernel compilation settings
155 # Kernel compilation settings
156 BUILD_KERNEL=${BUILD_KERNEL:=true}
156 BUILD_KERNEL=${BUILD_KERNEL:=true}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
157 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
158 KERNEL_THREADS=${KERNEL_THREADS:=1}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
159 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
160 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
161 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
162 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
163 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
164
164
165 # Kernel compilation from source directory settings
165 # Kernel compilation from source directory settings
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
166 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
167 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
168 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
169 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
170
170
171 # Reduce disk usage settings
171 # Reduce disk usage settings
172 REDUCE_APT=${REDUCE_APT:=true}
172 REDUCE_APT=${REDUCE_APT:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
173 REDUCE_DOC=${REDUCE_DOC:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
174 REDUCE_MAN=${REDUCE_MAN:=true}
175 REDUCE_VIM=${REDUCE_VIM:=false}
175 REDUCE_VIM=${REDUCE_VIM:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
176 REDUCE_BASH=${REDUCE_BASH:=false}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
177 REDUCE_HWDB=${REDUCE_HWDB:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
178 REDUCE_SSHD=${REDUCE_SSHD:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
179 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
180
180
181 # Encrypted filesystem settings
181 # Encrypted filesystem settings
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
182 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
183 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
184 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
185 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
186 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
187
187
188 # Chroot scripts directory
188 # Chroot scripts directory
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
189 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
190
190
191 # Packages required in the chroot build environment
191 # Packages required in the chroot build environment
192 APT_INCLUDES=${APT_INCLUDES:=""}
192 APT_INCLUDES=${APT_INCLUDES:=""}
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
193 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
194
194
195 # Packages required for bootstrapping
195 # Packages required for bootstrapping
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
196 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
197 MISSING_PACKAGES=""
197 MISSING_PACKAGES=""
198
198
199 #autoselect best apt mirror
200 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} netselect-apt"
201
199 # Packages installed for c/c++ build environment in chroot (keep empty)
202 # Packages installed for c/c++ build environment in chroot (keep empty)
200 COMPILER_PACKAGES=""
203 COMPILER_PACKAGES=""
201
204
202 set +x
205 set +x
203
206
204 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
207 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
205 if [ -n "$SET_ARCH" ] ; then
208 if [ -n "$SET_ARCH" ] ; then
206 echo "Setting Architecture specific settings"
209 echo "Setting Architecture specific settings"
207 ##################################
210 ##################################
208 # 64 bit config
211 # 64 bit config
209 ##################################
212 ##################################
210 if [ "$SET_ARCH" = 64 ] ; then
213 if [ "$SET_ARCH" = 64 ] ; then
211 echo "64 bit mode selected - Setting up enviroment"
214 echo "64 bit mode selected - Setting up enviroment"
212 # 64 bit depended settings
215 # 64 bit depended settings
213 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
216 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
214 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
217 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
215 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
218 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
216 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
219 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
217 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
220 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
218 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
221 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
219
222
220 if ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]) ; then
223 if ([ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]) ; then
221 # RPI 3 serie specific settings
224 # RPI 3 serie specific settings
222 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
225 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
223 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
226 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
224
227
225 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
228 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
226 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
229 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
227 else
230 else
228 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
231 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
229 exit 1
232 exit 1
230 fi
233 fi
231 fi
234 fi
232
235
233 ##################################
236 ##################################
234 # 32 bit config
237 # 32 bit config
235 ##################################
238 ##################################
236 if [ "$SET_ARCH" = 32 ] ; then
239 if [ "$SET_ARCH" = 32 ] ; then
237 echo "32 bit mode selected - Setting up enviroment"
240 echo "32 bit mode selected - Setting up enviroment"
238 #General 32bit configuration
241 #General 32bit configuration
239 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
242 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
240 KERNEL_ARCH=${KERNEL_ARCH:=arm}
243 KERNEL_ARCH=${KERNEL_ARCH:=arm}
241 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
244 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
242
245
243 #Raspberry setting grouped by board compability
246 #Raspberry setting grouped by board compability
244 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
247 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
245 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
248 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
246 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
249 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
247 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
250 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
248 RELEASE_ARCH=${RELEASE_ARCH:=armel}
251 RELEASE_ARCH=${RELEASE_ARCH:=armel}
249 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
252 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
250 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
253 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
251 fi
254 fi
252 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
255 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
253 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
256 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
254 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
255 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
258 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
256 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
259 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
257 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
260 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
258 fi
261 fi
259
262
260 #Device specific configuration
263 #Device specific configuration
261 case "$RPI_MODEL" in
264 case "$RPI_MODEL" in
262 0)
265 0)
263 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
266 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb} ;;
264 1)
267 1)
265 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
268 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb} ;;
266 1P)
269 1P)
267 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
270 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb} ;;
268 2)
271 2)
269 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
272 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
270 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
273 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
271 #Precompiled Kernel rpi2
274 #Precompiled Kernel rpi2
272 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
275 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
273 ;;
276 ;;
274 3)
277 3)
275 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
278 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
276 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
279 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
277 ;;
280 ;;
278 3P)
281 3P)
279 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
282 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
280 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
283 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
281 ;;
284 ;;
282 *)
285 *)
283 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
286 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
284 exit 1
287 exit 1
285 ;;
288 ;;
286 esac
289 esac
287 #end 32 bit
290 #end 32 bit
288 fi
291 fi
289 #SET_ARCH not set
292 #SET_ARCH not set
290 else
293 else
291 echo "error: Please set '32' or '64' as value for SET_ARCH"
294 echo "error: Please set '32' or '64' as value for SET_ARCH"
292 exit 1
295 exit 1
293 fi
296 fi
294
297
295 # Check if the internal wireless interface is supported by the RPi model
298 # Check if the internal wireless interface is supported by the RPi model
296 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
299 if [ "$ENABLE_WIRELESS" = true ] && ([ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ]) ; then
297 echo "error: The selected Raspberry Pi model has no internal wireless interface"
300 echo "error: The selected Raspberry Pi model has no internal wireless interface"
298 exit 1
301 exit 1
299 else
302 else
300 echo "Raspberry Pi model"
303 echo "Raspberry Pi model"
301 fi
304 fi
302
305
303 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
306 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
304 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
307 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
305 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
308 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
306 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
309 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
307 exit 1
310 exit 1
308 fi
311 fi
309 fi
312 fi
310
313
311 # Add libncurses5 to enable kernel menuconfig
314 # Add libncurses5 to enable kernel menuconfig
312 if [ "$KERNEL_MENUCONFIG" = true ] ; then
315 if [ "$KERNEL_MENUCONFIG" = true ] ; then
313 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
316 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
314 fi
317 fi
315
318
316 # Add ccache compiler cache for (faster) kernel cross (re)compilation
319 # Add ccache compiler cache for (faster) kernel cross (re)compilation
317 if [ "$KERNEL_CCACHE" = true ] ; then
320 if [ "$KERNEL_CCACHE" = true ] ; then
318 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
321 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
319 fi
322 fi
320
323
321 # Add cryptsetup package to enable filesystem encryption
324 # Add cryptsetup package to enable filesystem encryption
322 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
325 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
323 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
326 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
324 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
327 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
325
328
326 if [ -z "$CRYPTFS_PASSWORD" ] ; then
329 if [ -z "$CRYPTFS_PASSWORD" ] ; then
327 echo "error: no password defined (CRYPTFS_PASSWORD)!"
330 echo "error: no password defined (CRYPTFS_PASSWORD)!"
328 exit 1
331 exit 1
329 fi
332 fi
330 ENABLE_INITRAMFS=true
333 ENABLE_INITRAMFS=true
331 fi
334 fi
332
335
333 # Add initramfs generation tools
336 # Add initramfs generation tools
334 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
337 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
335 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
338 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
336 fi
339 fi
337
340
338 # Add device-tree-compiler required for building the U-Boot bootloader
341 # Add device-tree-compiler required for building the U-Boot bootloader
339 if [ "$ENABLE_UBOOT" = true ] ; then
342 if [ "$ENABLE_UBOOT" = true ] ; then
340 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
343 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
341 fi
344 fi
342
345
343 # Check if root SSH (v2) public key file exists
346 # Check if root SSH (v2) public key file exists
344 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
347 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
345 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
348 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
346 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
349 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
347 exit 1
350 exit 1
348 fi
351 fi
349 fi
352 fi
350
353
351 # Check if $USER_NAME SSH (v2) public key file exists
354 # Check if $USER_NAME SSH (v2) public key file exists
352 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
355 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
353 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
356 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
354 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
357 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
355 exit 1
358 exit 1
356 fi
359 fi
357 fi
360 fi
358
361
359 # Check if all required packages are installed on the build system
362 # Check if all required packages are installed on the build system
360 for package in $REQUIRED_PACKAGES ; do
363 for package in $REQUIRED_PACKAGES ; do
361 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
364 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
362 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
365 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
363 fi
366 fi
364 done
367 done
365
368
366 # If there are missing packages ask confirmation for install, or exit
369 # If there are missing packages ask confirmation for install, or exit
367 if [ -n "$MISSING_PACKAGES" ] ; then
370 if [ -n "$MISSING_PACKAGES" ] ; then
368 echo "the following packages needed by this script are not installed:"
371 echo "the following packages needed by this script are not installed:"
369 echo "$MISSING_PACKAGES"
372 echo "$MISSING_PACKAGES"
370
373
371 echo -n "\ndo you want to install the missing packages right now? [y/n] "
374 echo -n "\ndo you want to install the missing packages right now? [y/n] "
372 read confirm
375 read confirm
373 [ "$confirm" != "y" ] && exit 1
376 [ "$confirm" != "y" ] && exit 1
374
377
375 # Make sure all missing required packages are installed
378 # Make sure all missing required packages are installed
376 apt-get -qq -y install ${MISSING_PACKAGES}
379 apt-get -qq -y install ${MISSING_PACKAGES}
377 fi
380 fi
378
381
379 # Check if ./bootstrap.d directory exists
382 # Check if ./bootstrap.d directory exists
380 if [ ! -d "./bootstrap.d/" ] ; then
383 if [ ! -d "./bootstrap.d/" ] ; then
381 echo "error: './bootstrap.d' required directory not found!"
384 echo "error: './bootstrap.d' required directory not found!"
382 exit 1
385 exit 1
383 fi
386 fi
384
387
385 # Check if ./files directory exists
388 # Check if ./files directory exists
386 if [ ! -d "./files/" ] ; then
389 if [ ! -d "./files/" ] ; then
387 echo "error: './files' required directory not found!"
390 echo "error: './files' required directory not found!"
388 exit 1
391 exit 1
389 fi
392 fi
390
393
391 # Check if specified KERNELSRC_DIR directory exists
394 # Check if specified KERNELSRC_DIR directory exists
392 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
395 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
393 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
396 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
394 exit 1
397 exit 1
395 fi
398 fi
396
399
397 # Check if specified UBOOTSRC_DIR directory exists
400 # Check if specified UBOOTSRC_DIR directory exists
398 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
401 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
399 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
402 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
400 exit 1
403 exit 1
401 fi
404 fi
402
405
403 # Check if specified FBTURBOSRC_DIR directory exists
406 # Check if specified FBTURBOSRC_DIR directory exists
404 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
407 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
405 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
408 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
406 exit 1
409 exit 1
407 fi
410 fi
408
411
409 # Check if specified CHROOT_SCRIPTS directory exists
412 # Check if specified CHROOT_SCRIPTS directory exists
410 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
413 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
411 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
414 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
412 exit 1
415 exit 1
413 fi
416 fi
414
417
415 # Check if specified device mapping already exists (will be used by cryptsetup)
418 # Check if specified device mapping already exists (will be used by cryptsetup)
416 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
419 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
417 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
420 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
418 exit 1
421 exit 1
419 fi
422 fi
420
423
421 # Don't clobber an old build
424 # Don't clobber an old build
422 if [ -e "$BUILDDIR" ] ; then
425 if [ -e "$BUILDDIR" ] ; then
423 echo "error: directory ${BUILDDIR} already exists, not proceeding"
426 echo "error: directory ${BUILDDIR} already exists, not proceeding"
424 exit 1
427 exit 1
425 fi
428 fi
426
429
427 # Setup chroot directory
430 # Setup chroot directory
428 mkdir -p "${R}"
431 mkdir -p "${R}"
429
432
430 # Check if build directory has enough of free disk space >512MB
433 # Check if build directory has enough of free disk space >512MB
431 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
434 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
432 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
435 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
433 exit 1
436 exit 1
434 fi
437 fi
435
438
436 set -x
439 set -x
437
440
438 # Call "cleanup" function on various signals and errors
441 # Call "cleanup" function on various signals and errors
439 trap cleanup 0 1 2 3 6
442 trap cleanup 0 1 2 3 6
440
443
441 # Add required packages for the minbase installation
444 # Add required packages for the minbase installation
442 if [ "$ENABLE_MINBASE" = true ] ; then
445 if [ "$ENABLE_MINBASE" = true ] ; then
443 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
446 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
444 fi
447 fi
445
448
446 # Add required locales packages
449 # Add required locales packages
447 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
450 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || ([ -n XKB_MODEL ] || [ -n XKB_LAYOUT ] || [ -n XKB_VARIANT ] || [ -n XKB_OPTIONS ]); then
448 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
451 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
449 fi
452 fi
450
453
451 # Add parted package, required to get partprobe utility
454 # Add parted package, required to get partprobe utility
452 if [ "$EXPANDROOT" = true ] ; then
455 if [ "$EXPANDROOT" = true ] ; then
453 APT_INCLUDES="${APT_INCLUDES},parted"
456 APT_INCLUDES="${APT_INCLUDES},parted"
454 fi
457 fi
455
458
456 # Add dbus package, recommended if using systemd
459 # Add dbus package, recommended if using systemd
457 if [ "$ENABLE_DBUS" = true ] ; then
460 if [ "$ENABLE_DBUS" = true ] ; then
458 APT_INCLUDES="${APT_INCLUDES},dbus"
461 APT_INCLUDES="${APT_INCLUDES},dbus"
459 fi
462 fi
460
463
461 # Add iptables IPv4/IPv6 package
464 # Add iptables IPv4/IPv6 package
462 if [ "$ENABLE_IPTABLES" = true ] ; then
465 if [ "$ENABLE_IPTABLES" = true ] ; then
463 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
466 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
464 fi
467 fi
465
468
466 # Add openssh server package
469 # Add openssh server package
467 if [ "$ENABLE_SSHD" = true ] ; then
470 if [ "$ENABLE_SSHD" = true ] ; then
468 APT_INCLUDES="${APT_INCLUDES},openssh-server"
471 APT_INCLUDES="${APT_INCLUDES},openssh-server"
469 fi
472 fi
470
473
471 # Add alsa-utils package
474 # Add alsa-utils package
472 if [ "$ENABLE_SOUND" = true ] ; then
475 if [ "$ENABLE_SOUND" = true ] ; then
473 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
476 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
474 fi
477 fi
475
478
476 # Add rng-tools package
479 # Add rng-tools package
477 if [ "$ENABLE_HWRANDOM" = true ] ; then
480 if [ "$ENABLE_HWRANDOM" = true ] ; then
478 APT_INCLUDES="${APT_INCLUDES},rng-tools"
481 APT_INCLUDES="${APT_INCLUDES},rng-tools"
479 fi
482 fi
480
483
481 # Add fbturbo video driver
484 # Add fbturbo video driver
482 if [ "$ENABLE_FBTURBO" = true ] ; then
485 if [ "$ENABLE_FBTURBO" = true ] ; then
483 # Enable xorg package dependencies
486 # Enable xorg package dependencies
484 ENABLE_XORG=true
487 ENABLE_XORG=true
485 fi
488 fi
486
489
487 # Add user defined window manager package
490 # Add user defined window manager package
488 if [ -n "$ENABLE_WM" ] ; then
491 if [ -n "$ENABLE_WM" ] ; then
489 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
492 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
490
493
491 # Enable xorg package dependencies
494 # Enable xorg package dependencies
492 ENABLE_XORG=true
495 ENABLE_XORG=true
493 fi
496 fi
494
497
495 # Add xorg package
498 # Add xorg package
496 if [ "$ENABLE_XORG" = true ] ; then
499 if [ "$ENABLE_XORG" = true ] ; then
497 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
500 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
498 fi
501 fi
499
502
500 # Replace selected packages with smaller clones
503 # Replace selected packages with smaller clones
501 if [ "$ENABLE_REDUCE" = true ] ; then
504 if [ "$ENABLE_REDUCE" = true ] ; then
502 # Add levee package instead of vim-tiny
505 # Add levee package instead of vim-tiny
503 if [ "$REDUCE_VIM" = true ] ; then
506 if [ "$REDUCE_VIM" = true ] ; then
504 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
507 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
505 fi
508 fi
506
509
507 # Add dropbear package instead of openssh-server
510 # Add dropbear package instead of openssh-server
508 if [ "$REDUCE_SSHD" = true ] ; then
511 if [ "$REDUCE_SSHD" = true ] ; then
509 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
512 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
510 fi
513 fi
511 fi
514 fi
512
515
513 #backwards compability to jessie - untested
516 #backwards compability to jessie - untested
514 if [ "$RELEASE" != "jessie" ] ; then
517 if [ "$RELEASE" != "jessie" ] ; then
515 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
518 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
516 fi
519 fi
517
520
518 # Configure kernel sources if no KERNELSRC_DIR
521 # Configure kernel sources if no KERNELSRC_DIR
519 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
522 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
520 KERNELSRC_CONFIG=true
523 KERNELSRC_CONFIG=true
521 fi
524 fi
522
525
523 # Configure reduced kernel
526 # Configure reduced kernel
524 if [ "$KERNEL_REDUCE" = true ] ; then
527 if [ "$KERNEL_REDUCE" = true ] ; then
525 KERNELSRC_CONFIG=false
528 KERNELSRC_CONFIG=false
526 fi
529 fi
527
530
528 # Execute bootstrap scripts
531 # Execute bootstrap scripts
529 for SCRIPT in bootstrap.d/*.sh; do
532 for SCRIPT in bootstrap.d/*.sh; do
530 head -n 3 "$SCRIPT"
533 head -n 3 "$SCRIPT"
531 . "$SCRIPT"
534 . "$SCRIPT"
532 done
535 done
533
536
534 ## Execute custom bootstrap scripts
537 ## Execute custom bootstrap scripts
535 if [ -d "custom.d" ] ; then
538 if [ -d "custom.d" ] ; then
536 for SCRIPT in custom.d/*.sh; do
539 for SCRIPT in custom.d/*.sh; do
537 . "$SCRIPT"
540 . "$SCRIPT"
538 done
541 done
539 fi
542 fi
540
543
541 # Execute custom scripts inside the chroot
544 # Execute custom scripts inside the chroot
542 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
545 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
543 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
546 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
544 chroot_exec /bin/bash -x <<'EOF'
547 chroot_exec /bin/bash -x <<'EOF'
545 for SCRIPT in /chroot_scripts/* ; do
548 for SCRIPT in /chroot_scripts/* ; do
546 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
549 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
547 $SCRIPT
550 $SCRIPT
548 fi
551 fi
549 done
552 done
550 EOF
553 EOF
551 rm -rf "${R}/chroot_scripts"
554 rm -rf "${R}/chroot_scripts"
552 fi
555 fi
553
556
554 # Remove c/c++ build environment from the chroot
557 # Remove c/c++ build environment from the chroot
555 chroot_remove_cc
558 chroot_remove_cc
556
559
557 # Remove apt-utils
560 # Remove apt-utils
558 if [ "$RELEASE" = "jessie" ] ; then
561 if [ "$RELEASE" = "jessie" ] ; then
559 chroot_exec apt-get purge -qq -y --force-yes apt-utils
562 chroot_exec apt-get purge -qq -y --force-yes apt-utils
560 fi
563 fi
561
564
562 # Generate required machine-id
565 # Generate required machine-id
563 MACHINE_ID=$(dbus-uuidgen)
566 MACHINE_ID=$(dbus-uuidgen)
564 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
567 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
565 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
568 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
566
569
567 # APT Cleanup
570 # APT Cleanup
568 chroot_exec apt-get -y clean
571 chroot_exec apt-get -y clean
569 chroot_exec apt-get -y autoclean
572 chroot_exec apt-get -y autoclean
570 chroot_exec apt-get -y autoremove
573 chroot_exec apt-get -y autoremove
571
574
572 # Unmount mounted filesystems
575 # Unmount mounted filesystems
573 umount -l "${R}/proc"
576 umount -l "${R}/proc"
574 umount -l "${R}/sys"
577 umount -l "${R}/sys"
575
578
576 # Clean up directories
579 # Clean up directories
577 rm -rf "${R}/run/*"
580 rm -rf "${R}/run/*"
578 rm -rf "${R}/tmp/*"
581 rm -rf "${R}/tmp/*"
579
582
580 # Clean up files
583 # Clean up files
581 rm -f "${ETC_DIR}/ssh/ssh_host_*"
584 rm -f "${ETC_DIR}/ssh/ssh_host_*"
582 rm -f "${ETC_DIR}/dropbear/dropbear_*"
585 rm -f "${ETC_DIR}/dropbear/dropbear_*"
583 rm -f "${ETC_DIR}/apt/sources.list.save"
586 rm -f "${ETC_DIR}/apt/sources.list.save"
584 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
587 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
585 rm -f "${ETC_DIR}/*-"
588 rm -f "${ETC_DIR}/*-"
586 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
589 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
587 rm -f "${ETC_DIR}/resolv.conf"
590 rm -f "${ETC_DIR}/resolv.conf"
588 rm -f "${R}/root/.bash_history"
591 rm -f "${R}/root/.bash_history"
589 rm -f "${R}/var/lib/urandom/random-seed"
592 rm -f "${R}/var/lib/urandom/random-seed"
590 rm -f "${R}/initrd.img"
593 rm -f "${R}/initrd.img"
591 rm -f "${R}/vmlinuz"
594 rm -f "${R}/vmlinuz"
592 rm -f "${R}${QEMU_BINARY}"
595 rm -f "${R}${QEMU_BINARY}"
593
596
594 if [ "$ENABLE_QEMU" = true ] ; then
597 if [ "$ENABLE_QEMU" = true ] ; then
595 # Configure qemu compatible kernel
598 # Configure qemu compatible kernel
596 DTB_FILE=vexpress-v2p-ca15_a7.dtb
599 DTB_FILE=vexpress-v2p-ca15_a7.dtb
597 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
600 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
598 KERNEL_DEFCONFIG="vexpress_defconfig"
601 KERNEL_DEFCONFIG="vexpress_defconfig"
599 if [ "$KERNEL_MENUCONFIG" = false ] ; then
602 if [ "$KERNEL_MENUCONFIG" = false ] ; then
600 KERNEL_OLDDEFCONFIG=true
603 KERNEL_OLDDEFCONFIG=true
601 fi
604 fi
602
605
603 # Setup QEMU directory
606 # Setup QEMU directory
604 mkdir "${BASEDIR}/qemu"
607 mkdir "${BASEDIR}/qemu"
605
608
606 # Copy kernel image to QEMU directory
609 # Copy kernel image to QEMU directory
607 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
610 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
608
611
609 # Copy kernel config to QEMU directory
612 # Copy kernel config to QEMU directory
610 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
613 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
611
614
612 # Copy kernel dtbs to QEMU directory
615 # Copy kernel dtbs to QEMU directory
613 for dtb in "${BOOT_DIR}/"*.dtb ; do
616 for dtb in "${BOOT_DIR}/"*.dtb ; do
614 if [ -f "${dtb}" ] ; then
617 if [ -f "${dtb}" ] ; then
615 install_readonly "${dtb}" "${BASEDIR}/qemu/"
618 install_readonly "${dtb}" "${BASEDIR}/qemu/"
616 fi
619 fi
617 done
620 done
618
621
619 # Copy kernel overlays to QEMU directory
622 # Copy kernel overlays to QEMU directory
620 if [ -d "${BOOT_DIR}/overlays" ] ; then
623 if [ -d "${BOOT_DIR}/overlays" ] ; then
621 # Setup overlays dtbs directory
624 # Setup overlays dtbs directory
622 mkdir "${BASEDIR}/qemu/overlays"
625 mkdir "${BASEDIR}/qemu/overlays"
623
626
624 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
627 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
625 if [ -f "${dtb}" ] ; then
628 if [ -f "${dtb}" ] ; then
626 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
629 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
627 fi
630 fi
628 done
631 done
629 fi
632 fi
630
633
631 # Copy u-boot files to QEMU directory
634 # Copy u-boot files to QEMU directory
632 if [ "$ENABLE_UBOOT" = true ] ; then
635 if [ "$ENABLE_UBOOT" = true ] ; then
633 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
636 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
634 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
637 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
635 fi
638 fi
636 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
639 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
637 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
640 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
638 fi
641 fi
639 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
642 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
640 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
643 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
641 fi
644 fi
642 fi
645 fi
643
646
644 # Copy initramfs to QEMU directory
647 # Copy initramfs to QEMU directory
645 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
648 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
646 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
649 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
647 fi
650 fi
648 fi
651 fi
649
652
650 # Calculate size of the chroot directory in KB
653 # Calculate size of the chroot directory in KB
651 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
654 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
652
655
653 # Calculate the amount of needed 512 Byte sectors
656 # Calculate the amount of needed 512 Byte sectors
654 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
657 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
655 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
658 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
656 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
659 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
657
660
658 # The root partition is EXT4
661 # The root partition is EXT4
659 # This means more space than the actual used space of the chroot is used.
662 # This means more space than the actual used space of the chroot is used.
660 # As overhead for journaling and reserved blocks 35% are added.
663 # As overhead for journaling and reserved blocks 35% are added.
661 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
664 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
662
665
663 # Calculate required image size in 512 Byte sectors
666 # Calculate required image size in 512 Byte sectors
664 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
667 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
665
668
666 # Prepare image file
669 # Prepare image file
667 if [ "$ENABLE_SPLITFS" = true ] ; then
670 if [ "$ENABLE_SPLITFS" = true ] ; then
668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
671 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
669 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
672 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
673 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
671 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
674 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
672
675
673 # Write firmware/boot partition tables
676 # Write firmware/boot partition tables
674 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
677 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
675 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
678 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
676 EOM
679 EOM
677
680
678 # Write root partition table
681 # Write root partition table
679 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
682 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
680 ${TABLE_SECTORS},${ROOT_SECTORS},83
683 ${TABLE_SECTORS},${ROOT_SECTORS},83
681 EOM
684 EOM
682
685
683 # Setup temporary loop devices
686 # Setup temporary loop devices
684 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
687 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
685 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
688 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
686 else # ENABLE_SPLITFS=false
689 else # ENABLE_SPLITFS=false
687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
690 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
688 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
691 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
689
692
690 # Write partition table
693 # Write partition table
691 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
694 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
692 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
695 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
693 ${ROOT_OFFSET},${ROOT_SECTORS},83
696 ${ROOT_OFFSET},${ROOT_SECTORS},83
694 EOM
697 EOM
695
698
696 # Setup temporary loop devices
699 # Setup temporary loop devices
697 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
700 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
698 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
701 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
699 fi
702 fi
700
703
701 if [ "$ENABLE_CRYPTFS" = true ] ; then
704 if [ "$ENABLE_CRYPTFS" = true ] ; then
702 # Create dummy ext4 fs
705 # Create dummy ext4 fs
703 mkfs.ext4 "$ROOT_LOOP"
706 mkfs.ext4 "$ROOT_LOOP"
704
707
705 # Setup password keyfile
708 # Setup password keyfile
706 touch .password
709 touch .password
707 chmod 600 .password
710 chmod 600 .password
708 echo -n ${CRYPTFS_PASSWORD} > .password
711 echo -n ${CRYPTFS_PASSWORD} > .password
709
712
710 # Initialize encrypted partition
713 # Initialize encrypted partition
711 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
714 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
712
715
713 # Open encrypted partition and setup mapping
716 # Open encrypted partition and setup mapping
714 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
717 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
715
718
716 # Secure delete password keyfile
719 # Secure delete password keyfile
717 shred -zu .password
720 shred -zu .password
718
721
719 # Update temporary loop device
722 # Update temporary loop device
720 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
723 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
721
724
722 # Wipe encrypted partition (encryption cipher is used for randomness)
725 # Wipe encrypted partition (encryption cipher is used for randomness)
723 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
726 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
724 fi
727 fi
725
728
726 # Build filesystems
729 # Build filesystems
727 mkfs.vfat "$FRMW_LOOP"
730 mkfs.vfat "$FRMW_LOOP"
728 mkfs.ext4 "$ROOT_LOOP"
731 mkfs.ext4 "$ROOT_LOOP"
729
732
730 # Mount the temporary loop devices
733 # Mount the temporary loop devices
731 mkdir -p "$BUILDDIR/mount"
734 mkdir -p "$BUILDDIR/mount"
732 mount "$ROOT_LOOP" "$BUILDDIR/mount"
735 mount "$ROOT_LOOP" "$BUILDDIR/mount"
733
736
734 mkdir -p "$BUILDDIR/mount/boot/firmware"
737 mkdir -p "$BUILDDIR/mount/boot/firmware"
735 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
738 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
736
739
737 # Copy all files from the chroot to the loop device mount point directory
740 # Copy all files from the chroot to the loop device mount point directory
738 rsync -a "${R}/" "$BUILDDIR/mount/"
741 rsync -a "${R}/" "$BUILDDIR/mount/"
739
742
740 # Unmount all temporary loop devices and mount points
743 # Unmount all temporary loop devices and mount points
741 cleanup
744 cleanup
742
745
743 # Create block map file(s) of image(s)
746 # Create block map file(s) of image(s)
744 if [ "$ENABLE_SPLITFS" = true ] ; then
747 if [ "$ENABLE_SPLITFS" = true ] ; then
745 # Create block map files for "bmaptool"
748 # Create block map files for "bmaptool"
746 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
749 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
747 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
750 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
748
751
749 # Image was successfully created
752 # Image was successfully created
750 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
753 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
751 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
754 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
752 else
755 else
753 # Create block map file for "bmaptool"
756 # Create block map file for "bmaptool"
754 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
757 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
755
758
756 # Image was successfully created
759 # Image was successfully created
757 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
760 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
758
761
759 # Create qemu qcow2 image
762 # Create qemu qcow2 image
760 if [ "$ENABLE_QEMU" = true ] ; then
763 if [ "$ENABLE_QEMU" = true ] ; then
761 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
764 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
762 QEMU_SIZE=16G
765 QEMU_SIZE=16G
763
766
764 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
767 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
765 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
768 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
766
769
767 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
770 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
768 fi
771 fi
769 fi
772 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant